PartDesign Corps

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page PartDesign Body and the translation is 100% complete.
Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português do Brasil • ‎română • ‎русский • ‎한국어

PartDesign Body.svg PartDesign Corps

Emplacement du menu
Conception de pièces → Créer un corps
Ateliers
PartDesign
Raccourci par défaut
Aucun
Introduit dans la version
0.17
Voir aussi
Std Part, Édition de fonctions

Description

Un PartDesign Corps (Body) est l'élément de base pour créer des formes solides avec l'atelier PartDesign. Il peut contenir des esquisses, des objets Datum et des PartDesign Fonctionnalités (Features) afin de produire un simple solide contigu.

Le Corps fournit un objet Origine qui comprend les axes X, Y, Z, et les plans standards. Ces éléments peuvent être utilisés comme références pour ancrer des esquisses et des objets primitifs.

Ne pas confondre le PartDesign Body.svg PartDesign Corps (Body) avec le Std Part.svg Std Part. Le premier est un objet spécifique utilisé dans l'Workbench PartDesign.svg Atelier PartDesign, destiné à modéliser un simple solide contigu au moyen de PartDesign Fonctionnalités. Std Part est un objet de regroupement destiné à créer des assemblages. Il n'est pas utilisé pour la modélisation, juste pour organiser différents objets dans l'espace. Plusieurs corps et d'autres Std Parts peuvent être placés à l'intérieur d'un seul Std Part pour créer un assemblage complexe.

PartDesign Body tree.png PartDesign Body example.png

A gauche: l'arborescence montrant les entités qui produisent séquentiellement la forme finale de l'objet. A droite: l'objet définitif visible dans la Vue 3D.

Utilisation

Si aucun solide précédent n'est sélectionné:

  1. Appuyez sur le bouton PartDesign Body.svg Créer un nouveau corps et l'activer. Le nouveau corps est créé et devient automatiquement actif.
  2. Vous pouvez maintenant appuyer sur PartDesign NewSketch.svg PartDesign Nouvelle esquisse pour créer une esquisse dans le corps qui peut être utilisée avec PartDesign Pad.svg PartDesign Protusion.
  3. Alternativement, vous pouvez ajouter une PartDesign Fonction, par exemple un PartDesign AdditiveBox.svg PartDesign Cube additif.

Si un objet solide est sélectionné:

  1. Appuyez sur le bouton PartDesign Body.svg Créer un nouveau corps et l'activer. Un nouveau corps est créé contenant une seule Base Feature. Cet élément Fonction de base (Base Feature) est une simple référence à un autre objet précédemment créé ou importé dans le document. Voir Fonction de base pour plus d'informations. Un Corps existant ou une PartDesign Fonctionnalité ne peut pas être sélectionné lorsque vous appuyez sur le PartDesign Body.svg Créer un nouveau corps....

Remarques

  • Si aucun corps n'existe au moment où PartDesign NewSketch.svg PartDesign Nouvelle esquisse est sélectionné, un nouveau Corps sera automatiquement créé. Si un corps existe déjà, il doit être rendu actif avant d'utiliser PartDesign NewSketch.svg PartDesign Nouvelle esquisse.
  • Double-cliquez sur le Corps dans la Vue en arborescence du modèle ou ouvrez le menu contextuel (clic droit) et sélectionnez Toggle active body pour activer ou désactiver le Corps. Si un autre Corps est déjà actif, il sera automatiquement désactivé. Voir statut actif pour plus d'informations.

Propriétés

Un PartDesign Corps (classe PartDesign::Body) est dérivé d'une Part Fonctionnalité (classe Part::Feature), par conséquent il partage toutes les propriétés de ce dernier.

Outre les propriétés décrites dans Part Fonctionnalité, le PartDesign Corps a les propriétés suivantes dans l'Éditeur de propriétés.

Données

Base

  • DonnéesTip (Link): PartDesign Feature défini sur "Tip" est généralement la dernière fonction créée dans le Corps. Tip indique la forme finale du Corps qui est affichée dans la Vue 3D lorsque VueDisplay Mode Body est défini sur Tip. Voir Tip pour plus d'informations.
  • DonnéesBase Feature (Link): forme externe utilisée comme première PartDesign Feature dans le Corps. Il est généralement défini lorsque vous faites glisser un objet solide dans un Corps vide. Si aucun solide n'est importé de cette manière, cette propriété sera vide. Voir Base Feature pour plus d'informations.
  • DonnéesPlacement (Placement): position de l'objet dans la Vue 3D. Le placement est défini par un point Base (vecteur) et une Rotation (axe et angle). Voir Positionnement.
  • DonnéesGroup (LinkList): une liste avec les PartDesign Features dans le Corps.
Propriétés cachées de Données
  • DonnéesOrigin (Link): l'objet App Origin est la référence de position pour tous les éléments répertoriés dans DonnéesGroup.
  • Données_ Group Touched (Bool): si le groupe est coché ou non.

Aussi les propriétés cachées décrites dans Part Feature.

Vue

Base

  • VueDisplay Mode Body (Enumeration): définit le mode d'affichage spécifiquement pour le Corps avec l'un des deux types.
    • Through (à travers) valeur par défaut, affiche tous les objets à l'intérieur du Corps, c'est-à-dire les esquisses, PartDesign Features (fonctions), les objets de référence (datum), etc... Ce mode permet de visualiser les opérations partielles effectuées à l'intérieur du Corps et c'est donc le mode recommandé lors de l'ajout et de la modification de fonctions. Sélectionnez la fonction spécifique et définissez VueVisibility sur true ou appuyez sur la Barre d'espace du clavier.
    • Tip affiche uniquement la forme finale du corps, qui est définie par la propriété DonnéesTip. Tout le reste, y compris les esquisses, les PartDesign Fonctionnalités, les références, etc... ne sont pas affichées même s'elles sont visibles dans la Vue en arborescence. Ce mode est recommandé lorsque le Corps n'a pas besoin d'être modifié davantage, aussi une forme fixe est affichée. Ce mode est également recommandé lorsque vous souhaitez sélectionner les sous-éléments (sommets, arêtes et faces) de la forme finale à utiliser avec d'autres outils d'ateliers.

Conception du Corps

Solide contigu unique

Un PartDesign Corps est destiné à modéliser un solide contigu unique. Le sens de "contigu" est un élément fait d'une seule pièce, sans pièces mobiles ou solides déconnectés. Des exemples de solides contigus sont ceux qui sont fabriqués à partir d'une seule pièce de matière première par un procédé de coulée, de découpe ou de fraisage. Par exemple, un écrou, une rondelle et un boulon se compose chacun d'une seule pièce solide en métal, sans pièces mobiles, de sorte que chacun peut être modélisé par un PartDesign Corps. Les objets créés en soudant deux pièces peuvent également être modélisés par un seul Corps tant que le joint de soudure est solide et non destiné à être cassé.

Une fois que ces solides contigus sont rassemblés dans un certain type d'arrangement, ils deviennent alors un "assemblage". Dans un assemblage, les objets ne sont pas fusionnés, mais simplement "empilés" ou placés côte à côte et restent des objets individuels.

PartDesign Body contiguous separate.png PartDesign Body contiguous assembly.png

À gauche: trois solides contigus individuels, chacun modélisé par un PartDesign Corps. À droite: les différents Corps (Body) réunis en un assemblage.

Modification des fonctionnalités

Un PartDesign Corps est conçu pour fonctionner en créant un solide initial, soit à partir d'une esquisse soit à partir d'une forme primitive, puis en la modifiant par le biais de "fonctions" pour ajouter ou enlever de la matière de la forme précédente. Pour une explication complète, voir Édition de fonctions.

Un PartDesign Corps effectuera une union automatique des éléments solides à l'intérieur de celui-ci. Cela signifie que (1) les solides partiels doivent être en contact et (2) que les solides déconnectés ne sont pas autorisés.

PartDesign Body two intersection.png PartDesign Body two fusion.png

À gauche: deux solides individuels qui se coupent. À droite: un PartDesign Corps unique avec deux fonctions additives. Elles sont automatiquement fusionnées ensemble, donc au lieu de se recouper, elles forment un solide contigu unique.

PartDesign Body non-contiguous.png

À gauche: deux solides déconnectés. Ce n'est pas un PartDesign Corps valide. À droite: deux solides se touchant. Cela se traduit par un PartDesign Corps valide. La nouvelle fonction doit toujours entrer en contact avec la fonction précédente ou l'intersecter afin qu'elle lui soit fusionnée et devienne un solide contigu unique.

Remarque: d'autres programmes de CAO comme Catia autorisent les solides non contigus dans le même "Corps". Jusqu'à la v0.19, FreeCAD ne le permet toujours pas. Il y a eu des discussions sur le FreeCAD forum sur la levée de cette restriction, mais aucune décision concrète n'a été prise. Si vous souhaitez en savoir plus ou présenter différents points de vue, veuillez en discuter dans le forum.

Explication détaillée des propriétés

Statut actif

Un document ouvert peut contenir plusieurs Corps. Pour ajouter une nouvelle fonctionnalité à un Corps spécifique, il doit être rendu actif. Un Corps actif sera affiché dans la Vue en arborescence avec la couleur d'arrière-plan spécifiée par la valeur Active container dans l'éditeur de préférences (par défaut, bleu clair). le Corps actif sera également affiché en gras.

Pour activer ou désactiver un Corps:

  • Double-cliquez dessus dans la Vue en arborescence ou
  • Ouvrez le menu contextuel (clic droit) et sélectionnez Toggle active body (Activer/Désactiver le corps).

L'activation d'un Corps bascule automatiquement vers l'atelier PartDesign. Un seul Corps ne peut être actif à la fois.

PartDesign Body active.png

Document avec deux PartDesign Corps dont le second est actif.

Origine

L'Origine se compose des trois axes standard (X, Y, Z) et de trois plans standard (XY, XZ et YZ). Des Esquisses et autres objets peuvent être attachés à ces éléments lors de leur création.

  1. Créez le Corps.
  2. Si le Corps (Body) est sélectionné dans la Vue en arborescence lorsque le PartDesign NewSketch.svg Nouvelle esquisse est enfoncé, le Panneau des tâches s'ouvrira pour permettre de sélectionner un des plans.
  3. Si le Corps n'est pas sélectionné, sélectionnez l'origine à la place et rendez-le visible dans la Vue 3D en appuyant sur la barre Espace du clavier. Développez également l'objet Origin pour voir les axes et les plans.
  4. Sélectionnez un des plans, soit dans la Vue en arborescence soit dans la Vue 3D, puis appuyez sur PartDesign NewSketch.svg Nouvelle esquisse. L'esquisse sera créée sur le plan choisi.

Le même processus peut être utilisé lors de la création d'une géométrie de référence auxiliaire comme des PartDesign lignes, PartDesign Plans et PartDesign Systèmes de coordonnées.

Remarque: L'Origine est un objet App Origin (classe App::Origin) tandis que les axes et les plans sont respectivement des objets de type App::Line et App::Plane. Chacun de ces éléments peut être masqué et non masqué individuellement avec la barre Espace. Cela est utile pour choisir la référence correcte lors de la création d'autres objets.

Remarque 2: tous les éléments à l'intérieur du Corps sont référencés à l'Origine du Corps, ce qui signifie que le Corps peut être déplacé et tourné en référence au système de coordonnées global sans affecter le placement des éléments à l'intérieur.

PartDesign Body Origin tree.png PartDesign Body Origin view.png

A gauche: PartDesign Origin du Corps dans la Vue en arborescence et telle qu'elle apparaît affichée dans la Vue 3D. A droite: représentation des éléments Origin dans la Vue 3D.

Base Feature

La Base Feature (fonction de base) est la première PartDesign Fonction dans le Corps quand le Corps est basé sur une autre forme solide. Ce solide peut être créé par n'importe quel atelier ou importé à partir d'un fichier externe, par exemple un fichier STEP.

PartDesign Body BaseFeature tree.png

Deux PartDesign Corps, chacun avec une seule Base Feature qui est prises des solides créés précédemment.

Pour créer la fonction de base:

  1. sélectionner une forme solide externe à n'importe quel Corps et
  2. appuyez sur PartDesign Body.svg Créer un Corps. Cela créera un nouveau Corps avec une seule Base Feature.

Remarque: vous ne pouvez pas sélectionner un Corps existant ou l'une de ses fonctionnalités (features) lorsque vous appuyez sur PartDesign Body.svg Créer un Corps.

Si vous avez déjà un Corps, vous pouvez créer la fonction de base de cette manière :

  • dans la Vue en arborescence, choisissez un objet et faites-le glisser à l'intérieur du Corps, ou
  • dans l'Éditeur de propriétés, modifiez la valeur de la DonnéesBase Feature en appuyant sur la touche points de suspension ... et en choisissant un objet dans la liste. Dans ce cas, vous pouvez choisir un Corps existant pour être la Base Feature.

Remarque : le glisser-déposer ne fonctionne que pour les Corps qui n'ont pas encore de fonction de base (Base Feature).

Remarque 2 : si le Corps possède déjà plusieurs fonctions, lorsque vous faites glisser et déposez le solide externe, la fonction de base sera créée au début de la liste des fonctions, c'est-à-dire qu'elle sera ajoutée au début de la propriété DonnéesGroup.

La fonction de base (Base Feature) est entièrement facultative. Elle n'est présente que lors de l'inclusion d'un objet extérieur au Corps. Si aucun solide externe n'est inclus, vous pouvez toujours créer votre forme à l'aide d'Esquisses, de Protrusion, de Primitives additives et d'autres PartDesign Fonctionnalités. Dans ce cas, la propriété DonnéesBase Feature reste vide.

PartDesign Body BaseFeature Tip.svg

A gauche:un PartDesign Corps avec une fonction de base issue d'un objet solide externe et de nombreuses PartDesign Fonctions ultérieures en haut. A droite: un Corps qui n'a pas de fonction de base explicite (Base Feature).

Tip (fonction résultante)

Le Tip (fonction résultante) est une PartDesign Fonctionnalité qui est exposée à l'extérieur du Corps, c'est-à-dire que si un autre outil de n'importe quel atelier (par exemple, Part SimpleCopy.svg Part Copie simple ou Part Cut.svg Part Soustraction) doit utiliser la forme du Corps, il utilisera la forme du Tip. Autrement dit, le Tip est la représentation finale du Corps comme si l'historique paramétrique n'existait pas.

PartDesign Body Tip final.svg

A gauche: un PartDesign Corps avec l'historique paramétrique complet incluant les fonctions intermédiaires. À droite: le Tip est la forme finale qui peut être exportée à partir du Corps, tout en omettant l'historique du modèle.

Le Tip est automatiquement définie sur la dernière fonction créée dans le Corps. Néanmoins, il peut également être défini sur l'une des fonctionnalités intermédiaires en ouvrant le menu contextuel de la Vue en arborescence (clic droit) et en choisissant PartDesign MoveTip.svg Désigner comme fonction résultante ou en modifiant la valeur DonnéesTip du Corps dans l'Éditeur de propriétés.

Le fait de modifier le Tip permet en effet de revenir en arrière et d'ajouter des fonctionnalités qui auraient dû être ajoutées plus tôt. Cela expose également une forme différente aux outils externes.

Dans la Vue en arborescence, le Tip du Corps est reconnue par la PartDesign Fonctionnalité qui a une superposition d'icônes consistant en une flèche blanche à l'intérieur d'un cercle vert.

PartDesign Body Tip tree.png

Deux PartDesign Corps, chacun avec des PartDesign Fonctions. Le Tip est la dernière fonction de celles-ci et est marqué par un symbole de superposition.

Interaction avec d'autres ateliers

Par défaut, des PartDesign Fonctions à l'intérieur d'un Corps sont sélectionnables dans le but de modifier et d'ajouter d'autres fonctions avec les outils de l'atelier PartDesign. Néanmoins, il n'est pas conseillé de sélectionner les fonctions individuelles pour les utiliser avec des outils d'autres ateliers, tels que l'atelier Part et l'atelier Draft, des résultats inattendus peuvent apparaitre. Si cela est fait, dans la Vue rapport, un message d'erreur peut apparaître, Links go out of the allowed scope (Les liens sortent du champ d'application autorisé).

Par conséquent, pour les interactions avec d'autres ateliers, seul le Corps lui-même doit être sélectionné dans la Vue en arborescence. Dans les cas où il est nécessaire de sélectionner des sous-éléments spécifiques du Corps (sommets, arêtes et faces), la propriété VueDisplay Mode Body du Corps doit être basculée sur Tip. Lorsque ce mode est activé, l'accès aux objets sous le Corps (PartDesign Fonctions, les références (datum), esquisses) sont désactivées et tout sauf le Tip du Corps sera caché dans la Vue 3D.

Une fois que les sous-éléments ont été utilisés avec d'autres ateliers, la VueDisplay Mode Body peut être redéfinie sur Through.

PartDesign Body Tip Display mode.svg

A gauche: lorsque "Display Mode Body" est réglé sur Through, il est possible de sélectionner et d'effectuer des opérations avec la PartDesign Fonction; en général, ce n'est pas recommandé. A droite: lorsque "Display Mode Body" est réglé sur Tip toutes les sélections et opérations effectuées sur le Corps seront effectuées sur le Tip, en s'assurant que seule la forme finale du Corps est exposée.

Gestion de la visibilité

La visibilité du Corps remplace la visibilité de tout objet qu'il contient. Si le Corps est masqué, les objets qu'il contient seront également masqués, même si leur propriété individuelle VueVisibility est définie sur true.

Plusieurs Esquisses peuvent être visibles à la fois mais une seule PartDesign Fonction (résultat solide) peut être visible à la fois. Sélectionner une fonction cachée et appuyer sur la barre Espace du clavier la rendra visible et masquera automatiquement la fonction précédemment visible.

PartDesign Body Visibility.png

PartDesign Corps: plusieurs Esquisses peuvent être visibles simultanément, mais une seule PartDesign Fonctionnalité (feature) peut être visible à la fois, que ce soit le Tip ou non.

Ancrage

Les PartDesign Fonctions, tout comme les objets planaires, peuvent être ancrées à différents plans, généralement les plans standard définis par l'Origine du Corps ou à des PartDesign Plans de référence personnalisés.

Les esquisses sont normalement ancrées à un plan lors de leur création. De la même manière, les PartDesign Primitives additives peuvent également être ancrées. Ancrer ces objets à un plan permet de les déplacer dans le Corps en modifiant leur propriété DonnéesAttachment Offset. Pour plus d'informations sur les modes d'ancrage, voir Part Ancrage.

Une PartDesign Fonctionnalité (feature) qui n'est pas ancrée sera affichée avec un symbole de superposition rouge à côté de son icône dans la Vue en arborescence.

PartDesign Body Feature attachment.png

PartDesign Corps: les PartDesign Fonctions qui ne sont pas ancrées à un plan ou à un système de coordonnées seront affichées avec un symbole de superposition à côté de leur icône dans la Vue en arborescence.

Héritage

Un PartDesign Corps est formellement une instance de la classe PartDesign::Body, dont le parent est Part Feature (classe Part::Feature) via la classe intermédiaire Part::BodyBase et est complétée par une extension Origin.

FreeCAD core objects.svg

Diagramme simplifié des relations entre les objets centraux du programme. L'objet PartDesign::Body est destiné à construire des solides 3D paramétriques et est donc dérivé de l'objet de base Part::Feature. Il possède une Origine pour contrôler le placement des fonctionnalités utilisées à l'intérieur.

Script

Voir aussi: Débuter avec les scripts et Objets créés par script.

Voir Part Fonctionnalité (Feature) pour plus d'informations à propos de l'ajout d'objets au document.

Un PartDesign Corps (Body) est créé avec la méthode addObject() du document. Une fois qu'un Corps existe, des PartDesign Fonctionnalités, comme les primitives additives et soustractives, peuvent être ajoutées et attachées à ce Corps avec les méthodes addObject() ou addObjects() de ce Corps.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj.Label = "Custom label"

feat1 = App.ActiveDocument.addObject("PartDesign::AdditiveBox", "Box")
feat2 = App.ActiveDocument.addObject("PartDesign::AdditiveCylinder", "Cylinder")

obj.addObjects([feat1, feat2])
App.ActiveDocument.recompute()

Dans un document contenant plusieurs Corps, le Corps actif peut être défini par la méthode setActiveObject de la ActiveView. Le premier argument est la chaîne fixe "pdbody" et le deuxième argument est l'objet Corps (Body) qui doit être activé.

import FreeCAD as App
import FreeCADGui as Gui

doc = App.newDocument()
obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("PartDesign::Body", "Body")

Gui.ActiveDocument.ActiveView.setActiveObject("pdbody", obj1)
App.ActiveDocument.recompute()